-- Coded by: Exzu / EU-Aszune


satchelAddonControls = {
    ANT = { fontSize = "14", loc = "TOP", x = 0, y = 8, color = {1, 1, 1, 1}, text = "Satchel Scanner", },
    statusText = { fontSize = "16", loc = "LEFT", x = 5, y = 82, color = {0, 1, 0, 1}, text = "Current Status:", },
    scanText = { fontSize = "16", loc = "LEFT", x = 95, y = 82, color = {1, 0, 0, 1}, text = "Not Running", },
    tankText = { fontSize = "14", loc = "LEFT", x = 22, y = 65, color = {1, 1, 1, 1}, text = "Tank:", },
    tankScanningText = { fontSize = "14", loc = "LEFT", x = 52, y = 65, color = {1, 0, 0, 1}, text = "Not Scanning...", },
    tankdg1 = { fontSize = "14", loc = "LEFT", x = 6, y = 50, color = {0, 0.6, 0.8, 1}, text = "# ...", },
    tankdg2 = { fontSize = "14", loc = "LEFT", x = 6, y = 35, color = {0, 0.6, 0.8, 1}, text = "# ...", },
    healerText = { fontSize = "14", loc = "LEFT", x = 22, y = 20, color = {1, 1, 1, 1}, text = "Healer:", },
    healScanningText = { fontSize = "14", loc = "LEFT", x = 62, y = 20, color = {1, 0, 0, 1}, text = "Not Scanning...", },
    healdg1 = { fontSize = "14", loc = "LEFT", x = 6, y = 5, color = {0, 0.6, 0.8, 1}, text = "# ...", },
    healdg2 = { fontSize = "14", loc = "LEFT", x = 6, y = -10, color = {0, 0.6, 0.8, 1}, text = "# ...", },
    dpsText = { fontSize = "14", loc = "LEFT", x = 22, y = -25, color = {1, 1, 1, 1}, text = "DPS:", },
    dpsScanningText = { fontSize = "14", loc = "LEFT", x = 47, y = -25, color = {1, 0, 0, 1}, text = "Not Scanning...", },
    dpsdg1 = { fontSize = "14", loc = "LEFT", x = 6, y = -40, color = {0, 0.6, 0.8, 1}, text = "# ...", },
    dpsdg2 = { fontSize = "14", loc = "LEFT", x = 6, y = -55, color = {0, 0.6, 0.8, 1}, text = "# ...", },
};


-- Variables
local playSound = true;
local UpdateInterval = 3.0;
local running = false;
local scanForTank = true;
local scanForHeal = true;
local scanForDps = false;

-- Remember this for localization later on
--local ant = "Satchel Scanner";  
--local status = "Current Status:";
--local tankString = "Tank:";
--local healerString = "Healer:";
--local dpsString = "DPS:";
-- End of remember

local runVar = {"Not Running", "Running"};
local addonVersion = "1.8.0";
local satchelFound = false; -- To be used for soundwarning

-- Dungeon Scan Var
local heroicVar = {"# Hour of Twilight Heroic!", "# Cataclysm Heroic!"};
local scanVar = {"# ...", "# Searching..."};
local classScan = {"Not Scanning...","Scanning...","Satchel Found!"};
local ctaVar = {"Call to Arms: Tank","Call to Arms: Healer","Call to Arms: Dps"};


-- Addon Colors
--local colors = { red = {1,0,0,1}, green = {0,1,0,1}, yellow = {1,1,0,1}, } -- To be used in an upcoming table
local redColor = {1,0,0,1};
local greenColor = {0,1,0,1};
local yellowColor = {1,1,0,1};

function stopScanning()
	if running then
		running = false
		DEFAULT_CHAT_FRAME:AddMessage("Stopped Scanning for Satchels...", 1, 0, 0);
		satchelAddonControls.scanText.textFrame:SetTextColor(unpack(redColor));
		satchelAddonControls.scanText.textFrame:SetText(runVar[1]);
		satchelAddonControls.tankScanningText.textFrame:SetText(classScan[1]);
		satchelAddonControls.tankScanningText.textFrame:SetTextColor(unpack(redColor));
		satchelAddonControls.healScanningText.textFrame:SetText(classScan[1]);
		satchelAddonControls.healScanningText.textFrame:SetTextColor(unpack(redColor));
		satchelAddonControls.dpsScanningText.textFrame:SetText(classScan[1]);
		satchelAddonControls.dpsScanningText.textFrame:SetTextColor(unpack(redColor));
		satchelAddonControls.tankdg1.textFrame:SetText(scanVar[1]);
		satchelAddonControls.tankdg2.textFrame:SetText(scanVar[1]);
		satchelAddonControls.healdg1.textFrame:SetText(scanVar[1]);
		satchelAddonControls.healdg2.textFrame:SetText(scanVar[1]);
		satchelAddonControls.dpsdg1.textFrame:SetText(scanVar[1]);
		satchelAddonControls.dpsdg2.textFrame:SetText(scanVar[1]);
	end
end

function startScanning()
	if not running and (scanForTank or scanForHeal or scanForDps) then
		running = true
		DEFAULT_CHAT_FRAME:AddMessage("Scanning for Satchels...", 1, 0, 0);
		satchelAddonControls.scanText.textFrame:SetTextColor(unpack(greenColor));
		satchelAddonControls.scanText.textFrame:SetText(runVar[2]);
		if scanForTank then
			satchelAddonControls.tankdg1.textFrame:SetText(scanVar[2]);
			satchelAddonControls.tankdg2.textFrame:SetText(scanVar[2]);
		end
		if scanForHeal then
			satchelAddonControls.healdg1.textFrame:SetText(scanVar[2]);
			satchelAddonControls.healdg2.textFrame:SetText(scanVar[2]);
		end
		if scanForDps then
			satchelAddonControls.dpsdg1.textFrame:SetText(scanVar[2]);
			satchelAddonControls.dpsdg2.textFrame:SetText(scanVar[2]);
		end
		RequestLFDPlayerLockInfo();
	else
		print("Must scan for atleast one class before starting the program!");
	end
end

-- Database values
function createConfig()
	SatchelScannerDB = {}
	dbAdd("updateint", 3);
	dbAdd("sounds", true);
	dbAdd("version", addonVersion);
	dbAdd("scanTank", true);
	dbAdd("scanHeal", true);
	dbAdd("scanDps", false);
	readConfig();
end

function readConfig() -- Reads values from DB
	if not SatchelScannerDB then
		createConfig();
	else
		playSound = SatchelScannerDB["sounds"];
		UpdateInterval = SatchelScannerDB["updateint"];
		dbVersion = SatchelScannerDB["version"];
		scanForTank = SatchelScannerDB["scanTank"]
		scanForTankButton:SetChecked(scanForTank)
		scanForHeal = SatchelScannerDB["scanHeal"]
		scanForHealButton:SetChecked(scanForHeal)
		scanForDps = SatchelScannerDB["scanDps"]
		scanForDpsButton:SetChecked(scanForDps)
	end	
end

function dbAdd(var, arg) -- Updates values in db
	SatchelScannerDB[var] = arg;
end

-- Scanner - DO NOT MODIFY!
function satchelFinder(role, id)
		local eligible, forTank, forHealer, forDamage, itemCount, money, xp = GetLFGRoleShortageRewards(id, 1)
		if (itemCount ~= 0 or money ~= 0 or xp ~= 0) then
			if forTank and scanForTank and role == "tank" then
				return true;
			end
			if forHealer and scanForHeal and role == "heal" then
				return true;
			end
			if forDamage and scanForDps and role == "dps" then
				print("This shouldnt be printed");
				return true;
			end
		end
end

function SatchelScan(self, event, arg)
	if event == "ADDON_LOADED" and arg == "SatchelScanner" then
		readConfig();
	end
	if running then		
		if event == "LFG_UPDATE_RANDOM_INFO" then
			if scanForTank then
				if satchelFinder("tank", 434) then
					satchelAddonControls.tankdg1.textFrame:SetText(heroicVar[1]);
				else
					satchelAddonControls.tankdg1.textFrame:SetText(scanVar[2]);
				end
				if satchelFinder("tank", 301) then
					satchelAddonControls.tankdg2.textFrame:SetText(heroicVar[2]);
				else
					satchelAddonControls.tankdg2.textFrame:SetText(scanVar[2]);
				end
				if not satchelFinder("tank", 434) and not satchelFinder("tank", 301) then
					satchelAddonControls.tankScanningText.textFrame:SetText(classScan[2]);
					satchelAddonControls.tankScanningText.textFrame:SetTextColor(unpack(yellowColor));
				end
				if satchelFinder("tank", 434) or satchelFinder("tank", 301) then
					satchelFound = true;
					satchelAddonControls.tankScanningText.textFrame:SetText(classScan[3]);
					satchelAddonControls.tankScanningText.textFrame:SetTextColor(unpack(greenColor));
					RaidNotice_AddMessage(RaidWarningFrame, ctaVar[1], ChatTypeInfo["RAID_WARNING"])
				end
			end
			-- Healer Scanner
			if scanForHeal then
				if satchelFinder("heal", 434) then
					satchelAddonControls.healdg1.textFrame:SetText(heroicVar[1]);
				else
					satchelAddonControls.healdg1.textFrame:SetText(scanVar[2]);
				end
				if satchelFinder("heal", 301) then
					satchelAddonControls.healdg2.textFrame:SetText(heroicVar[2]);
				else
					satchelAddonControls.healdg2.textFrame:SetText(scanVar[2]);
				end
				if not satchelFinder("heal", 434) and not satchelFinder("heal", 301) then
					satchelAddonControls.healScanningText.textFrame:SetText(classScan[2]);
					satchelAddonControls.healScanningText.textFrame:SetTextColor(unpack(yellowColor));
				end
				if satchelFinder("heal", 434) or satchelFinder("heal", 301) then
					satchelFound = true;
					satchelAddonControls.healScanningText.textFrame:SetText(classScan[3]);
					satchelAddonControls.healScanningText.textFrame:SetTextColor(unpack(greenColor));
					RaidNotice_AddMessage(RaidWarningFrame, ctaVar[2], ChatTypeInfo["RAID_WARNING"])
				end
			end
			-- Dps Scanner
			if scanForDps then
				print("This shouldnt be printed");
				if satchelFinder("dps", 434) then
					satchelAddonControls.dpsdg1.textFrame:SetText(heroicVar[1]);
				else
					satchelAddonControls.dpsdg1.textFrame:SetText(scanVar[2]);
				end
				if satchelFinder("dps", 301) then
					satchelAddonControls.dpsdg2.textFrame:SetText(heroicVar[2]);
				else
					satchelAddonControls.dpsdg2.textFrame:SetText(scanVar[2]);
				end
				if not satchelFinder("dps", 434) and not satchelFinder("dps", 301) then
					satchelAddonControls.dpsScanningText.textFrame:SetText(classScan[2]);
					satchelAddonControls.dpsScanningText.textFrame:SetTextColor(unpack(yellowColor));
				end
				if satchelFinder("dps", 434) or satchelFinder("dps", 301) then
					satchelFound = true;
					satchelAddonControls.dpsScanningText.textFrame:SetText(classScan[3]);
					satchelAddonControls.dpsScanningText.textFrame:SetTextColor(unpack(greenColor));
					RaidNotice_AddMessage(RaidWarningFrame, ctaVar[3], ChatTypeInfo["RAID_WARNING"])
				end
			end
			if scanForDps or scanForTank or scanForHeal then
				if not satchelFinder("tank", 434) and not satchelFinder("tank", 301) and not satchelFinder("heal", 434) and not satchelFinder("heal", 301) and not satchelFinder("dps", 434) and not satchelFinder("dps", 301) then
					satchelFound = false;
				end
			end
		else
			print("This event should not have been printed" .. event);
		end
	end
end

function savetoData()
	if scanForTankButton:GetChecked() then
		dbAdd("scanTank", true);
		scanForTank = true;
	else
		dbAdd("scanTank", false);
		scanForTank = false;
	end
	if scanForHealButton:GetChecked() then
		dbAdd("scanHeal", true);
		scanForHeal = true;
	else
		dbAdd("scanHeal", false);
		scanForHeal = false;
	end
	if scanForDpsButton:GetChecked() then
		dbAdd("scanDps", true);
		scanForDps = true;
	else
		dbAdd("scanDps", false);
		scanForDps = false;
	end
end

function drawFrames()
	SatchelScanner = {};
	SatchelScanner.panel = CreateFrame("Frame", "MyAddonPanel", UIParent );
	SatchelScanner.panel.name = "Satchel Scanner";
	InterfaceOptions_AddCategory(SatchelScanner.panel);

	SatchelScanner.childpanel = CreateFrame("Frame", "MyAddonChild", SatchelScanner.panel);
	SatchelScanner.childpanel.name = "Options";
	SatchelScanner.childpanel.parent = SatchelScanner.panel.name;
	InterfaceOptions_AddCategory(SatchelScanner.childpanel);
	SatchelScanner.panel.okay = function(self) savetoData(); end;
	
 	configurationText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	configurationText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	configurationText:SetPoint("TOPLEFT", 10, -10);
	configurationText:SetText("Configuration!");
	-- Tank CheckBox
	scanForTankButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanForTankButton:SetPoint("TOPLEFT", 8, -25);
 	scanForTankText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanForTankText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanForTankText:SetPoint("TOPLEFT", 30, -29);
	scanForTankText:SetText("Scan for Tank Satchels");
	-- Healer CheckBox
	scanForHealButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanForHealButton:SetPoint("TOPLEFT", 8, -45);
 	scanForHealText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanForHealText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanForHealText:SetPoint("TOPLEFT", 30, -49);
	scanForHealText:SetText("Scan for Healer Satchels");
	-- Dps CheckBox
 	scanForDpsButton = CreateFrame("CheckButton", nil, SatchelScanner.childpanel, "ChatConfigCheckButtonTemplate");
	scanForDpsButton:SetPoint("TOPLEFT", 8, -65);
 	scanForDpsText = SatchelScanner.childpanel:CreateFontString(nil, "OVERLAY")
	scanForDpsText:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", 14, "OUTLINE");
	scanForDpsText:SetPoint("TOPLEFT", 30, -69);
	scanForDpsText:SetText("Scan for Dps Satchels");
	
	
	MainFrame = CreateFrame("Frame", "DragFrame2", UIParent)
	MainFrame:SetMovable(true)
	MainFrame:EnableMouse(true)
	MainFrame:SetScript("OnMouseDown", function(self, button)
		if button == "LeftButton" and not self.isMoving then
			self:StartMoving();
			self.isMoving = true;
		end
	end)
	MainFrame:SetScript("OnMouseUp", function(self, button)
		if button == "LeftButton" and self.isMoving then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	MainFrame:SetScript("OnHide", function(self)
		if ( self.isMoving ) then
			self:StopMovingOrSizing();
			self.isMoving = false;
		end
	end)
	MainFrame:SetWidth(256);
	MainFrame:SetHeight(190);
	MainFrame:SetPoint("BOTTOMLEFT", 800, 400);
	MainFrame:SetFrameStrata("BACKGROUND")
	MainFrame:SetBackdrop({ 
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", 
		edgeFile = "Interface\\Addons\\SatchelScanner\\border\\border.tga", tile = false, tileSize = 0, edgeSize = 8, 
		insets = { left = 0, right = 0, top = 0, bottom = 0 }
	});
	-- Scan Button
	local scanButton = CreateFrame("Button",nil,MainFrame,"UIPanelButtonTemplate");
	scanButton:SetWidth(80);
	scanButton:SetHeight(25);
	scanButton:SetPoint("BOTTOM", -80, 5);
	scanButton:SetText("Start");
	scanButton:SetScript("OnClick", startScanning);
	-- Stop Button
	local stopButton = CreateFrame("Button",nil,MainFrame,"UIPanelButtonTemplate");
	stopButton:SetWidth(80);
	stopButton:SetHeight(25);
	stopButton:SetPoint("BOTTOM", 80, 5);
	stopButton:SetText("Stop");
	stopButton:SetScript("OnClick", stopScanning);
	-- Close Button
	local closeButton = CreateFrame("Button",nil,MainFrame,"UIPanelButtonTemplate");
	closeButton:SetWidth(20);
	closeButton:SetHeight(20);
	closeButton:SetPoint("TOP",112,-5);
	closeButton:SetScript("OnClick",function() MainFrame:Hide(); end);
	--local iconClose = closeButton:CreateTexture("Close Button", "OVERLAY");
	--iconClose:SetTexture("Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up.png");
	--iconClose:SetAllPoints(closeButton);
	closeButton:SetText("X");
	-- Config Button
	local configButton = CreateFrame("Button",nil,MainFrame,"UIPanelButtonTemplate");
	configButton:SetWidth(60);
	configButton:SetHeight(25);
	configButton:SetPoint("BOTTOM", 0, 5);
	configButton:SetText("Config");
	configButton:SetScript("OnClick",function() InterfaceOptionsFrame_OpenToCategory(SatchelScanner.childpanel); end);
	-- Class Icons
	local tankIcon = CreateFrame("Frame",nil,MainFrame);
	tankIcon:SetWidth(15);
	tankIcon:SetHeight(15);
	tankIcon:SetPoint("LEFT",6,65);
	local iconTank = tankIcon:CreateTexture("Tank Icon","ARTWORK");
	iconTank:SetTexture("Interface\\Addons\\SatchelScanner\\icons\\tankIcon.tga");
	iconTank:SetAllPoints(tankIcon);
	local healIcon = CreateFrame("Frame",nil,MainFrame);
	healIcon:SetWidth(15);
	healIcon:SetHeight(15);
	healIcon:SetPoint("LEFT",6,20);
	local iconHeal = healIcon:CreateTexture("Healer Icon","ARTWORK");
	iconHeal:SetTexture("Interface\\Addons\\SatchelScanner\\icons\\healerIcon.tga");
	iconHeal:SetAllPoints(healIcon);
	local dpsIcon = CreateFrame("Frame",nil,MainFrame);
	dpsIcon:SetWidth(15);
	dpsIcon:SetHeight(15);
	dpsIcon:SetPoint("LEFT",6,-25);
	local iconDps = dpsIcon:CreateTexture("DPS Icon","ARTWORK");
	iconDps:SetTexture("Interface\\Addons\\SatchelScanner\\icons\\dpsIcon.tga");
	iconDps:SetAllPoints(dpsIcon);
end

function drawText() -- Draws the Text -- 
	for i, controlData in pairs(satchelAddonControls) do
		controlData.textFrame = MainFrame:CreateFontString(nil, "OVERLAY")
		controlData.textFrame:SetFont("Interface\\Addons\\SatchelScanner\\fonts\\font.TTF", controlData.fontSize, "OUTLINE");
		controlData.textFrame:SetPoint(controlData.loc, controlData.x, controlData.y);
		controlData.textFrame:SetTextColor(unpack(controlData.color));
		controlData.textFrame:SetText(controlData.text);
	end
end

-- On Load
function SatchelScanner_OnLoad(self)
	DEFAULT_CHAT_FRAME:AddMessage("Satchel Scanner 1.4.0 Loaded!", 1, 0, 0.5);
	DEFAULT_CHAT_FRAME:AddMessage("->> Type /ss3 for commands!", 1, 0, 0.5);
	self:RegisterEvent("LFG_UPDATE_RANDOM_INFO")
	self:RegisterEvent("ADDON_LOADED");
	self:SetScript("OnEvent", SatchelScan)
	drawFrames();
	drawText();
	SLASH_SATCHELSCANNER1, SLASH_SATCHELSCANNER2 = "/satchelscan", "/ss3"
	SlashCmdList.SATCHELSCANNER = function(msg)
		if msg == "toggle" then
			if MainFrame:IsShown() then
				MainFrame:Hide();
				msg = ""
			elseif not MainFrame:IsShown() then
				MainFrame:Show();
				msg = ""
			end
		elseif msg == "reset" then -- Not being used by now, will completely reset the addon to standard settings.
			-- checkifSatchel();
		elseif msg == "config" then
			InterfaceOptionsFrame_OpenToCategory(SatchelScanner.childpanel);
		else
			DEFAULT_CHAT_FRAME:AddMessage("====== Satchel Scanner ======", 1, 0, 0.5);
			DEFAULT_CHAT_FRAME:AddMessage("->> Type '/ss3 toggle' to show/hide the frame", 1, 0, 0.5);
			DEFAULT_CHAT_FRAME:AddMessage("->> Type '/ss3 reset' to reset the addon", 1, 0, 0.5);
			DEFAULT_CHAT_FRAME:AddMessage("->> Type '/ss3 config' to configure the addon", 1, 0, 0.5);
			msg = ""
		end
	end
end

-- This is the OnUpdate Function

function SatchelScanner_OnUpdate(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
	while (self.TimeSinceLastUpdate > UpdateInterval) do
		if running then
			RequestLFDPlayerLockInfo();
			if satchelFound and running and playSound then
				PlaySoundFile("Sound\\interface\\RaidWarning.wav", "Master")
			end
		end
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - UpdateInterval;
	end
end


